#include "def.h"
#include "../b.h"

void
prologue(void)
{
	prf("\tjmp\tend\n");
}

void
epilogue(void)
{
	prf("end:\tcall\tchain\n");
	prf("\t.quad %s\n", prevfix ? "2b" : "0");
}

void
label(int l)
{
	prf("%l:\n", l);
}

void
clab(int l)
{
	prf(".data; %l: .quad 1f; .text\n1:", l);
}

void
etcop(int n)
{
	prf("\t.quad n%o\n", n);
}
void
binop(int n)
{
	prf("\t.quad b%o\n", n);
}
void
unaop(int n)
{
	prf("\t.quad u%o\n", n);
}
void
opsym(char *op, char *s)
{
	prf("\t.quad %s,%n\n", op, s);
}
void
oplab(char *op, int l)
{
	if(l == 0)
		prf("\t.quad %s,1f\n", op);
	else
		prf("\t.quad %s,%l\n", op, l);
}
void
opint(char *op, int i)
{
	prf("\t.quad %s,%D\n", op, i);
}
void
opconst(char *op, word w)
{
	prf("\t.quad %s,%wO\n", op, w);
}
void
wdsym(char *s)
{
	prf("\t.quad %n\n", s);
}
void
wdlab(int l)
{
	if(l == 0)
		prf("\t.quad 1f\n");
	else
		prf("\t.quad %l\n", l);
}
void
wdint(int i)
{
	prf("\t.quad %D\n", i);
}
void
wdconst(word w)
{
	prf("\t.quad %wO\n", w);
}

void
global(char *s)
{
	prf(".globl %n\n", s);
}

void
textsym(void)
{
	prf(".text\n");
	prf("1: ");
}

void
datasym(char *s)
{
	prf(".data\n");
	if(s)
		prf("%n: ", s);
	else
		prf("1: ");
}

void
bsssym(char *s)
{
	prf(".bss\n");
	if(s)
		prf("%n: ", s);
	else
		prf("1: ");
}

void
skip(int n)
{
	printf(".=.+%D", n);
}

void
fixup(char *s, int n)
{
	if(s)
		fprf(tmpfil, "2: .quad %s,%n", prevfix ? "2b" : "0", s);
	else
		fprf(tmpfil, "2: .quad %s,1b", prevfix ? "2b" : "0");
	if(n != 0)
		fprf(tmpfil, "+%D", n);
	putc('\n', tmpfil);
	prevfix = 1;
}

void
startstr(int n)
{
	fprf(tmpfil, "%l: .byte ", n);
}

void
strchar(int c)
{
	fprf(tmpfil, "%O, ", c);
}

void
endstr(void)
{
	fprf(tmpfil, "0; .align 8\n");
}
